--
-- This script file reloads a database that was unloaded using "dbunload".
--
-- (Version:  17.0.11.7058)
--


-- Database file: C:\FormAnalyzer\Database\FAMain.db
-- Database CHAR collation: 1250POL, NCHAR collation: UCA
-- Connection Character Set: windows-1250
--
-- CREATE DATABASE command: CREATE DATABASE 'C:\\FormAnalyzer\\Database\\FAMain.db' LOG ON 'C:\\FormAnalyzer\\Database\\FAMain.log' PAGE SIZE 4096 COLLATION '1250POL(CaseSensitivity=Ignore)' NCHAR COLLATION 'UCA(CaseSensitivity=Ignore;AccentSensitivity=Ignore;PunctuationSensitivity=Primary)' BLANK PADDING OFF JCONNECT ON CHECKSUM ON DBA USER '***' DBA PASSWORD '***' SYSTEM PROC AS DEFINER OFF
--


SET OPTION date_order = 'YMD'
go

SET OPTION PUBLIC.preserve_source_format = 'OFF'
go

SET TEMPORARY OPTION tsql_outer_joins = 'ON'
go


-------------------------------------------------
--   Create dbspaces
-------------------------------------------------

CREATE DBSPACE "LOOKUP" AS 'FALkp.db'
go

CREATE DBSPACE "RESULTS" AS 'FARes.db'
go

CREATE DBSPACE "STATISTIC" AS 'FAStat.db'
go

CREATE DBSPACE "REPORTS" AS 'FARep.db'
go

CREATE DBSPACE "CONFIG" AS 'FAConfig.db'
go


-------------------------------------------------
--   Create users
-------------------------------------------------

GRANT CONNECT,GROUP,DBA TO "ADMIN" IDENTIFIED BY ENCRYPTED '\x01\x0d\x67\x89\x62\xb6\x86\xc0\x59\x40\xda\x1d\xf9\x4b\xe5\xa9\x9c\x49\xd2\x4a\x15\xe1\xbd\xf2\x64\x5b\x52\x8b\xe7\x29\x90\xa7\xb6\xcf\x3d\x66\xcf'
go

GRANT CONNECT,GROUP TO "ARBITER" IDENTIFIED BY ENCRYPTED '\x01\xad\x67\x5f\xa1\x28\x38\xf0\x31\x77\x7c\x90\x65\xc0\x8f\x9b\xc8\xea\x26\x8d\x10\x23\xfb\x70\xde\x0b\x50\xa6\x68\x4d\xc8\x23\xfe\xbd\x0f\xe2\x26'
go

GRANT CONNECT,GROUP TO "AUTHOR" IDENTIFIED BY ENCRYPTED '\x01\xc5\x67\x2e\xb3\x0a\x31\xb6\x6d\x79\xb1\x47\xe3\xc3\x78\xa1\xa0\xc0\xd2\x5a\xdd\x23\xe6\x2c\x44\x99\x12\x25\x38\x12\x22\x5d\xea\x6c\x6c\xf9\x6c'
go

GRANT CONNECT,GROUP TO "CERTIFIER" IDENTIFIED BY ENCRYPTED '\x01\xaf\x67\x56\x83\x88\xd1\x7c\x58\x29\x2e\x70\xb8\xf5\x3c\x57\xd9\xcf\xb7\x51\x37\x2e\xdb\xa9\x25\x36\x62\xb6\x35\xee\x74\xfb\xf2\x15\x31\x38\xa1'
go

GRANT CONNECT,GROUP TO "CLASSIFIER" IDENTIFIED BY ENCRYPTED '\x01\x59\x67\x93\x40\xf8\x80\x19\xa7\x49\xf0\x13\xfc\x0c\x79\x31\x68\x4b\xa1\x7a\xe5\xd9\xaa\x25\x03\xae\x54\xa6\xb5\x36\xa1\x57\xd2\x0d\x38\x53\x6b'
go

GRANT CONNECT,GROUP TO "CONTROLLER" IDENTIFIED BY ENCRYPTED '\x01\xf9\x67\xf1\x2a\x16\x59\xa3\x82\x86\xf2\xea\x06\x3d\x44\x49\xef\xad\xa4\xf6\xe1\x19\xd6\x9c\xbf\x31\xfa\x5d\xeb\x38\xaf\x57\x3f\xa1\x27\x45\xd6'
go

GRANT CONNECT,GROUP TO "DESIGNER" IDENTIFIED BY ENCRYPTED '\x01\x84\x67\xeb\x95\xf5\xa4\x70\x19\x98\xa1\x8b\x3c\xc8\x88\xa2\x9a\xd1\x38\xf0\x3f\x8f\xc5\x8b\xe7\x9e\x31\xbd\xe0\x8e\x6d\x6d\xb6\x87\xbe\x80\x2b'
go

GRANT CONNECT,GROUP TO "SCHEDULER" IDENTIFIED BY ENCRYPTED '\x01\xf4\x67\xa1\x38\x31\xa9\x2b\xc0\xce\x0e\x5d\x11\x86\x66\x2e\x26\x6c\x30\x88\xcb\x1a\xa0\x69\x6b\x0e\x63\x59\x41\x31\xa9\xa6\x67\xb4\x50\x20\x90'
go

GRANT CONNECT,GROUP TO "VERIFIER" IDENTIFIED BY ENCRYPTED '\x01\x24\x67\xb9\xad\xf9\xa4\xc9\xa2\x73\x85\x53\x27\xf0\x83\x05\x58\x97\x1b\xd7\x5f\x00\x99\xf4\xe3\xc7\x54\x1c\x00\xdf\xa7\x1f\x06\xfc\x31\x38\xa1'
go

GRANT CONNECT,GROUP TO "VERPERM" IDENTIFIED BY ENCRYPTED '\x01\x0a\x67\xf5\x31\x43\x5d\xed\xe5\x90\xa6\xa9\xdd\xca\x11\x38\xdf\xe4\x19\x45\xdd\x45\x9a\x4d\x49\x4d\xa1\x2f\x1e\xef\xc5\x14\x9f\xc7\xfa\xf9\xdb'
go

GRANT SELECT ON SYS.SYSUSERPERM TO PUBLIC;
go


-------------------------------------------------
--   Create group memberships
-------------------------------------------------

GRANT MEMBERSHIP IN GROUP "AUTHOR" TO "CLASSIFIER"
go

GRANT MEMBERSHIP IN GROUP "VERPERM" TO "ARBITER"
go

GRANT MEMBERSHIP IN GROUP "VERPERM" TO "CERTIFIER"
go

GRANT MEMBERSHIP IN GROUP "VERPERM" TO "CONTROLLER"
go

GRANT MEMBERSHIP IN GROUP "VERPERM" TO "VERIFIER"
go


-------------------------------------------------
--   Create tables
-------------------------------------------------

CREATE TABLE "ADMIN"."AcqBarcode" (
    "acqid"                          integer NOT NULL
   ,"barcode"                        char(32) NOT NULL
   ,CONSTRAINT "ACQBARCODE_PK" PRIMARY KEY ("acqid" ASC,"barcode" ASC) 
)
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."AcqBarcode" TO "AUTHOR" 
go

GRANT SELECT ON "ADMIN"."AcqBarcode" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."AcqBox" (
    "prefix"                         char(8) NOT NULL
   ,"number"                         integer NOT NULL
   ,CONSTRAINT "ACQBOX_PK" PRIMARY KEY ("prefix" ASC) 
)
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."AcqBox" TO "AUTHOR" 
go

CREATE TABLE "ADMIN"."AcqError" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"code"                           integer NOT NULL
   ,"note"                           char(255) NOT NULL
   ,"creator"                        char(128) NOT NULL DEFAULT current user
   ,"created"                        timestamp NOT NULL DEFAULT current timestamp
   ,"driver"                         char(128) NULL
   ,CONSTRAINT "ACQERROR_PK" PRIMARY KEY ("id" ASC) 
)
go

GRANT INSERT ON "ADMIN"."AcqError" TO "AUTHOR" 
go

GRANT SELECT ON "ADMIN"."AcqError" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."AcqProfile" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"name"                           char(64) NOT NULL
   ,"note"                           char(255) NULL
   ,"safe"                           smallint NOT NULL DEFAULT 0
   ,"volid"                          integer NOT NULL
   ,"driver"                         char(128) NOT NULL
   ,"device"                         char(128) NOT NULL
   ,"devstate"                       long varchar NOT NULL
   ,"counter"                        integer NULL
   ,"scantype"                       integer NOT NULL DEFAULT 0
   ,"separator"                      integer NOT NULL DEFAULT 0
   ,"sepskip"                        integer NOT NULL DEFAULT 0
   ,"sepstop"                        integer NOT NULL DEFAULT 0
   ,"docsize"                        integer NULL
   ,"side"                           integer NOT NULL
   ,"source"                         integer NOT NULL
   ,"processor"                      long binary NULL
   ,"cfgid"                          integer NULL
   ,"doctempl"                       char(64) NULL
   ,"status"                         integer NOT NULL
   ,"creator"                        char(128) NOT NULL DEFAULT current user
   ,"created"                        timestamp NOT NULL DEFAULT current timestamp
   ,"editor"                         char(128) NULL
   ,"edited"                         timestamp NULL
   ,"boxes"                          smallint NOT NULL DEFAULT 0
   ,"boxprefix"                      char(16) NULL
   ,"boxseq"                         smallint NOT NULL DEFAULT 0
   ,"blank"                          smallint NOT NULL DEFAULT 0
   ,"compress_bw"                    integer NULL
   ,"compress_gray"                  integer NULL
   ,"compress_color"                 integer NULL
   ,"bsideblank"                     smallint NOT NULL DEFAULT 0
   ,CONSTRAINT "ACQPROFILE_PK" PRIMARY KEY ("id" ASC) 
)
go

ALTER TABLE "ADMIN"."AcqProfile"
    ADD CONSTRAINT "ACQPROFILE_AK" UNIQUE ( "name" )
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."AcqProfile" TO "AUTHOR" 
go

GRANT SELECT ON "ADMIN"."AcqProfile" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."Action" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"name"                           char(64) NOT NULL
   ,CONSTRAINT "ACTION_PK" PRIMARY KEY ("id" ASC) 
)
go

ALTER TABLE "ADMIN"."Action"
    ADD CONSTRAINT "ACTION_AK" UNIQUE ( "name" )
go

GRANT SELECT ON "ADMIN"."Action" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."Archive" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"creator"                        char(128) NOT NULL DEFAULT current user
   ,"created"                        timestamp NOT NULL DEFAULT current timestamp
   ,CONSTRAINT "ARCHIVE_PK" PRIMARY KEY ("id" ASC) 
)
go

GRANT INSERT ON "ADMIN"."Archive" TO "DESIGNER" 
go

GRANT SELECT ON "ADMIN"."Archive" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."Box" (
    "obid"                           integer NOT NULL
   ,"volid"                          integer NOT NULL
   ,"parent"                         integer NOT NULL
   ,"name"                           char(64) NULL
   ,"hold"                           integer NOT NULL DEFAULT 0 CONSTRAINT "CKC_HOLD_BOX" check("hold" in( -1,0,1,2 ) )
   ,"imgctrlid"                      integer NULL
   ,"classifierid"                   integer NULL
   ,"expid"                          integer NULL
   ,"archid"                         integer NULL
   ,CONSTRAINT "BOX_PK" PRIMARY KEY ("obid" ASC) 
)
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."Box" TO "AUTHOR" 
go

GRANT SELECT ON "ADMIN"."Box" TO "PUBLIC" 
go

GRANT UPDATE ON "ADMIN"."Box" TO "VERPERM" 
go

CREATE TABLE "ADMIN"."BoxState" (
    "id"                             integer NOT NULL
   ,"icstate"                        long varchar NULL
   ,"clsstate"                       long binary NULL
   ,CONSTRAINT "BOXSTATE_PK" PRIMARY KEY ("id" ASC) 
) IN "RESULTS"
go

GRANT DELETE ON "ADMIN"."BoxState" TO "AUTHOR" 
go

GRANT INSERT,DELETE ON "ADMIN"."BoxState" TO "CLASSIFIER" 
go

GRANT SELECT ON "ADMIN"."BoxState" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."Cleanup" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"status"                         integer NOT NULL
   ,"creator"                        char(128) NOT NULL DEFAULT current user
   ,"created"                        timestamp NOT NULL DEFAULT current timestamp
   ,"executed"                       timestamp NULL
   ,CONSTRAINT "CLEANUP_PK" PRIMARY KEY ("id" ASC) 
)
go

GRANT SELECT ON "ADMIN"."Cleanup" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."ClpOptions" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"edoc"                           long varchar NOT NULL
   ,"editor"                         char(128) NOT NULL DEFAULT current user
   ,"edited"                         timestamp NOT NULL DEFAULT current timestamp
   ,CONSTRAINT "CLPOPTIONS_PK" PRIMARY KEY ("id" ASC) 
)
go

GRANT SELECT ON "ADMIN"."ClpOptions" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."ClpFolder" (
    "id"                             integer NOT NULL
   ,CONSTRAINT "CLPFOLDER_PK" PRIMARY KEY ("id" ASC) 
)
go

GRANT SELECT ON "ADMIN"."ClpFolder" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."ConfigFile" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"fname"                          char(128) NOT NULL
   ,"creator"                        char(128) NOT NULL DEFAULT current user
   ,"created"                        timestamp NOT NULL DEFAULT current timestamp
   ,"editor"                         char(128) NULL
   ,"edited"                         timestamp NULL
   ,CONSTRAINT "CONFIGFILE_PK" PRIMARY KEY ("id" ASC) 
)
go

ALTER TABLE "ADMIN"."ConfigFile"
    ADD CONSTRAINT "CONFIGFILE_AK" UNIQUE ( "fname" )
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."ConfigFile" TO "DESIGNER" 
go

GRANT SELECT ON "ADMIN"."ConfigFile" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."DocTemplate" (
    "cfgid"                          integer NOT NULL
   ,"name"                           char(64) NOT NULL
   ,"vlstid"                         integer NULL
   ,CONSTRAINT "DOCTEMPLATE_PK" PRIMARY KEY ("cfgid" ASC,"name" ASC) 
)
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."DocTemplate" TO "DESIGNER" 
go

GRANT SELECT ON "ADMIN"."DocTemplate" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."Document" (
    "obid"                           integer NOT NULL
   ,"docid"                          integer NOT NULL DEFAULT autoincrement
   ,"boxid"                          integer NOT NULL
   ,"number"                         integer NOT NULL
   ,"errauto"                        integer NULL
   ,"fsource"                        char(255) NULL
   ,"fext"                           char(16) NULL
   ,CONSTRAINT "DOCUMENT_PK" PRIMARY KEY ("obid" ASC) 
)
go

ALTER TABLE "ADMIN"."Document"
    ADD CONSTRAINT "DOCUMENT_AK" UNIQUE ( "docid" )
go

ALTER TABLE "ADMIN"."Document"
    ADD CONSTRAINT "DOCNUMBER_AK" UNIQUE ( "boxid","number" )
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."Document" TO "AUTHOR" 
go

GRANT SELECT ON "ADMIN"."Document" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."ExpError" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"code"                           integer NOT NULL
   ,"note"                           char(255) NOT NULL
   ,"creator"                        char(128) NOT NULL DEFAULT current user
   ,"created"                        timestamp NOT NULL DEFAULT current timestamp
   ,"docid"                          integer NOT NULL
   ,"pgnumber"                       integer NULL
   ,CONSTRAINT "EXPERROR_PK" PRIMARY KEY ("id" ASC) 
)
go

GRANT INSERT,DELETE ON "ADMIN"."ExpError" TO "DESIGNER" 
go

GRANT SELECT ON "ADMIN"."ExpError" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."Export" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"dnumber"                        integer NOT NULL
   ,"creator"                        char(128) NOT NULL DEFAULT current user
   ,"created"                        timestamp NOT NULL DEFAULT current timestamp
   ,CONSTRAINT "EXPORT_PK" PRIMARY KEY ("id" ASC) 
)
go

GRANT INSERT ON "ADMIN"."Export" TO "DESIGNER" 
go

GRANT SELECT ON "ADMIN"."Export" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."ExportImage" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"obid"                           integer NOT NULL
   ,"volid"                          integer NOT NULL
   ,"fext"                           char(16) NOT NULL
   ,"expid"                          integer NULL
   ,CONSTRAINT "EXPORTIMAGE_PK" PRIMARY KEY ("id" ASC) 
)
go

GRANT DELETE ON "ADMIN"."ExportImage" TO "AUTHOR" 
go

GRANT INSERT ON "ADMIN"."ExportImage" TO "DESIGNER" 
go

GRANT SELECT ON "ADMIN"."ExportImage" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."FADbStatus" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"major1"                         integer NOT NULL
   ,"major2"                         integer NOT NULL
   ,"minor1"                         integer NOT NULL
   ,"minor2"                         integer NOT NULL
   ,"version"                        char(32) NOT NULL
   ,"note"                           char(255) NULL
   ,"creator"                        char(128) NOT NULL DEFAULT current user
   ,"created"                        timestamp NOT NULL DEFAULT current timestamp
   ,PRIMARY KEY ("id" ASC) 
) IN "CONFIG"
go

GRANT SELECT ON "ADMIN"."FADbStatus" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."FALog" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"logid"                          integer NULL
   ,"mode"                           integer NOT NULL
   ,"operation"                      integer NOT NULL
   ,"obid"                           integer NULL
   ,"note"                           char(255) NULL
   ,"creator"                        char(128) NOT NULL DEFAULT current user
   ,"created"                        timestamp NOT NULL DEFAULT current timestamp
   ,PRIMARY KEY ("id" ASC) 
) IN "STATISTIC"
go

GRANT SELECT,INSERT ON "ADMIN"."FALog" TO "PUBLIC" 
go

GRANT SELECT,DELETE,UPDATE ON "ADMIN"."FALog" TO "SCHEDULER" 
go

CREATE TABLE "ADMIN"."FAOption" (
    "name"                           char(32) NOT NULL
   ,"value"                          char(32) NOT NULL
   ,CONSTRAINT "FAOPTIONNAME_PK" PRIMARY KEY ("name" ASC) 
)
go

ALTER TABLE "ADMIN"."FAOption"
    ADD CONSTRAINT "FAOPTIONNAME_AK" UNIQUE ( "name" )
go

GRANT SELECT ON "ADMIN"."FAOption" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."Folder" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"parent"                         integer NOT NULL
   ,"name"                           char(64) NOT NULL
   ,"creator"                        char(128) NOT NULL DEFAULT current user
   ,"created"                        timestamp NOT NULL DEFAULT current timestamp
   ,CONSTRAINT "FOLDER_PK" PRIMARY KEY ("id" ASC) 
)
go

ALTER TABLE "ADMIN"."Folder"
    ADD CONSTRAINT "FOLDERNAME_AK" UNIQUE ( "parent","name" )
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."Folder" TO "AUTHOR" 
go

GRANT SELECT ON "ADMIN"."Folder" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."History" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"action"                         integer NOT NULL
   ,"obid"                           integer NOT NULL
   ,"creator"                        char(128) NOT NULL DEFAULT current user
   ,"created"                        timestamp NOT NULL DEFAULT current timestamp
   ,"span"                           integer NULL
   ,"quality"                        integer NULL
   ,"qauto"                          integer NULL
   ,CONSTRAINT "HISTORY_PK" PRIMARY KEY ("id" ASC) 
)
go

GRANT INSERT ON "ADMIN"."History" TO "AUTHOR" 
go

GRANT UPDATE ON "ADMIN"."History" TO "CONTROLLER" 
go

GRANT SELECT ON "ADMIN"."History" TO "PUBLIC" 
go

GRANT INSERT ON "ADMIN"."History" TO "VERPERM" 
go

CREATE TABLE "ADMIN"."ICMode" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"name"                           char(32) NOT NULL
   ,"note"                           char(255) NULL
   ,"cols"                           integer NOT NULL DEFAULT 4
   ,"rows"                           integer NOT NULL DEFAULT 2
   ,"zooms"                          integer NOT NULL DEFAULT 1
   ,"bckcolor"                       integer NOT NULL DEFAULT 14811135
   ,"scncolor"                       integer NOT NULL DEFAULT 14811135
   ,"filter"                         integer NOT NULL DEFAULT 16395
   ,"dflags"                         integer NOT NULL DEFAULT 0
   ,"hflags"                         integer NOT NULL DEFAULT 1008
   ,"gflags"                         integer NOT NULL DEFAULT 2
   ,"diconflags"                     integer NOT NULL DEFAULT 0
   ,CONSTRAINT "ICMODE_PK" PRIMARY KEY ("id" ASC) 
) IN "CONFIG"
go

ALTER TABLE "ADMIN"."ICMode"
    ADD CONSTRAINT "ICMODE_AK" UNIQUE ( "name" )
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."ICMode" TO "ADMIN" 
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."ICMode" TO "DESIGNER" 
go

GRANT SELECT ON "ADMIN"."ICMode" TO "PUBLIC" 
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."ICMode" TO "SCHEDULER" 
go

CREATE TABLE "ADMIN"."ICCfgModes" (
    "idmode"                         integer NOT NULL
   ,"idconfig"                       integer NOT NULL
   ,"number"                         integer NOT NULL
) IN "CONFIG"
go

ALTER TABLE "ADMIN"."ICCfgModes"
    ADD CONSTRAINT "ICCFGMODES_PK" UNIQUE ( "idconfig","idmode","number" )
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."ICCfgModes" TO "ADMIN" 
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."ICCfgModes" TO "DESIGNER" 
go

GRANT SELECT ON "ADMIN"."ICCfgModes" TO "PUBLIC" 
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."ICCfgModes" TO "SCHEDULER" 
go

CREATE TABLE "ADMIN"."ICScript" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"name"                           char(32) NOT NULL
   ,"note"                           char(255) NULL
   ,"type"                           integer NOT NULL DEFAULT 0
   ,"body"                           varchar(8192) NOT NULL
   ,CONSTRAINT "ICSCRIPT_PK" PRIMARY KEY ("id" ASC) 
) IN "CONFIG"
go

ALTER TABLE "ADMIN"."ICScript"
    ADD CONSTRAINT "ICSCRIPTNAME_AK" UNIQUE ( "name" )
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."ICScript" TO "ADMIN" 
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."ICScript" TO "DESIGNER" 
go

GRANT SELECT ON "ADMIN"."ICScript" TO "PUBLIC" 
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."ICScript" TO "SCHEDULER" 
go

CREATE TABLE "ADMIN"."ICConfig" (
    "idconfig"                       integer NOT NULL
   ,"flags"                          integer NOT NULL DEFAULT 15
   ,"threads"                        integer NOT NULL DEFAULT 2
   ,"idloadscript"                   integer NULL
   ,"idscreenscript"                 integer NULL
   ,"idacceptscript"                 integer NULL
   ,"newdocstatus"                   integer NOT NULL DEFAULT 1
   ,CONSTRAINT "ICCONFIG_PK" PRIMARY KEY ("idconfig" ASC) 
) IN "CONFIG"
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."ICConfig" TO "ADMIN" 
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."ICConfig" TO "DESIGNER" 
go

GRANT SELECT ON "ADMIN"."ICConfig" TO "PUBLIC" 
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."ICConfig" TO "SCHEDULER" 
go

CREATE TABLE "ADMIN"."ImageExtension" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"ext"                            char(8) NOT NULL INLINE 8 PREFIX 8
   ,"name"                           char(16) NOT NULL INLINE 16 PREFIX 8
   ,"note"                           char(255) NULL
   ,CONSTRAINT "IMAGEEXTENSION_PK" PRIMARY KEY ("id" ASC) 
)
go

ALTER TABLE "ADMIN"."ImageExtension"
    ADD CONSTRAINT "IMAGEEXTENSION_AK" UNIQUE ( "name" )
go

GRANT SELECT ON "ADMIN"."ImageExtension" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."Job" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"cfgid"                          integer NOT NULL
   ,"creator"                        char(128) NOT NULL DEFAULT current user
   ,"created"                        timestamp NOT NULL DEFAULT current timestamp
   ,"editor"                         char(128) NULL
   ,"edited"                         timestamp NULL
   ,CONSTRAINT "JOB_PK" PRIMARY KEY ("id" ASC) 
)
go

ALTER TABLE "ADMIN"."Job"
    ADD CONSTRAINT "JOB_AK" UNIQUE ( "id","cfgid" )
go

GRANT SELECT ON "ADMIN"."Job" TO "PUBLIC" 
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."Job" TO "SCHEDULER" 
go

CREATE TABLE "ADMIN"."JobTempate" (
    "jobid"                          integer NOT NULL
   ,"cfgid"                          integer NOT NULL
   ,"doctempl"                       char(64) NOT NULL
   ,CONSTRAINT "JOBTEMPATE_PK" PRIMARY KEY ("jobid" ASC,"cfgid" ASC,"doctempl" ASC) 
)
go

GRANT SELECT ON "ADMIN"."JobTempate" TO "PUBLIC" 
go

GRANT INSERT,DELETE ON "ADMIN"."JobTempate" TO "SCHEDULER" 
go

CREATE TABLE "ADMIN"."JobUsers" (
    "userid"                         char(128) NOT NULL
   ,"jobid"                          integer NOT NULL
   ,CONSTRAINT "JOBUSERS_PK" PRIMARY KEY ("userid" ASC) 
)
go

GRANT SELECT ON "ADMIN"."JobUsers" TO "PUBLIC" 
go

GRANT INSERT,DELETE ON "ADMIN"."JobUsers" TO "SCHEDULER" 
go

CREATE TABLE "ADMIN"."LkpUpdates" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"tblowner"                       char(128) NOT NULL
   ,"tblname"                        char(128) NOT NULL
   ,"colname"                        char(128) NOT NULL
   ,"parent"                         integer NULL
   ,"obid"                           integer NULL
   ,"zone"                           char(128) NOT NULL
   ,"value"                          char(128) NOT NULL
   ,"state"                          integer NOT NULL
   ,"creator"                        char(128) NOT NULL DEFAULT current user
   ,"created"                        timestamp NOT NULL DEFAULT current timestamp
   ,"controller"                     char(128) NULL
   ,"controlled"                     timestamp NULL
   ,CONSTRAINT "LKPUPDATES_PK" PRIMARY KEY ("id" ASC) 
)
go

GRANT INSERT ON "ADMIN"."LkpUpdates" TO "CLASSIFIER" 
go

GRANT UPDATE ON "ADMIN"."LkpUpdates" TO "CONTROLLER" 
go

GRANT SELECT ON "ADMIN"."LkpUpdates" TO "PUBLIC" 
go

GRANT INSERT ON "ADMIN"."LkpUpdates" TO "VERPERM" 
go

CREATE TABLE "ADMIN"."Lookup" (
    "tblowner"                       char(128) NOT NULL
   ,"tblname"                        char(128) NOT NULL
   ,CONSTRAINT "LOOKUP_PK" PRIMARY KEY ("tblowner" ASC,"tblname" ASC) 
)
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."Lookup" TO "DESIGNER" 
go

GRANT SELECT ON "ADMIN"."Lookup" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."Object" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"status"                         integer NOT NULL
   ,"error"                          integer NOT NULL DEFAULT 0
   ,"creator"                        char(128) NOT NULL DEFAULT current user
   ,"created"                        timestamp NOT NULL DEFAULT current timestamp
   ,"cfgid"                          integer NULL
   ,"doctempl"                       char(64) NULL
   ,"verifier1id"                    integer NULL
   ,"verifier2id"                    integer NULL
   ,"arbiterid"                      integer NULL
   ,"certifierid"                    integer NULL
   ,"controllerid"                   integer NULL
   ,"verifier1"                      char(128) NULL
   ,"verifier2"                      char(128) NULL
   ,"arbiter"                        char(128) NULL
   ,"certifier"                      char(128) NULL
   ,"controller"                     char(128) NULL
   ,CONSTRAINT "OBJECT_PK" PRIMARY KEY ("id" ASC) 
)
go

GRANT INSERT,UPDATE ON "ADMIN"."Object" TO "AUTHOR" 
go

GRANT SELECT ON "ADMIN"."Object" TO "PUBLIC" 
go

GRANT UPDATE ON "ADMIN"."Object" TO "VERPERM" 
go

CREATE TABLE "ADMIN"."Page" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"obid"                           integer NOT NULL
   ,"number"                         integer NOT NULL
   ,"rotate"                         integer NOT NULL DEFAULT 0
   ,"skew"                           float NOT NULL DEFAULT 0
   ,"empty"                          smallint NOT NULL DEFAULT 0
   ,"endorser"                       char(64) NULL
   ,"rescan"                         smallint NOT NULL DEFAULT 0
   ,"stream"                         smallint NOT NULL DEFAULT 0
   ,"color"                          integer NOT NULL DEFAULT 0
   ,CONSTRAINT "PAGE_PK" PRIMARY KEY ("id" ASC) 
)
go

ALTER TABLE "ADMIN"."Page"
    ADD CONSTRAINT "PAGENUMBER_AK" UNIQUE ( "obid","number" )
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."Page" TO "AUTHOR" 
go

GRANT SELECT ON "ADMIN"."Page" TO "PUBLIC" 
go

GRANT UPDATE ON "ADMIN"."Page" TO "VERPERM" 
go

CREATE TABLE "ADMIN"."PageResults" (
    "id"                             integer NOT NULL
   ,"res"                            long binary NOT NULL
   ,CONSTRAINT "PAGERESULTS_PK" PRIMARY KEY ("id" ASC) 
) IN "RESULTS"
go

GRANT INSERT,DELETE ON "ADMIN"."PageResults" TO "AUTHOR" 
go

GRANT SELECT ON "ADMIN"."PageResults" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."PageTemp" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"obid"                           integer NOT NULL
   ,CONSTRAINT "PAGETEMP_PK" PRIMARY KEY ("id" ASC) 
) IN "RESULTS"
go

GRANT DELETE ON "ADMIN"."PageTemp" TO "AUTHOR" 
go

GRANT INSERT,DELETE ON "ADMIN"."PageTemp" TO "CLASSIFIER" 
go

GRANT SELECT ON "ADMIN"."PageTemp" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."Recycle" (
    "spid"                           integer NOT NULL
   ,"volid"                          integer NOT NULL
   ,"pageid"                         integer NOT NULL
   ,"fsource"                        bit NOT NULL
   ,"fext"                           char(16) NULL
)
go

GRANT SELECT,INSERT,DELETE ON "ADMIN"."Recycle" TO "AUTHOR" 
go

CREATE TABLE "ADMIN"."Reload" (
    "obid"                           integer NOT NULL
   ,"srcid"                          integer NOT NULL
   ,"fainst"                         char(32) NOT NULL
   ,CONSTRAINT "RELOAD_PK" PRIMARY KEY ("obid" ASC) 
)
go

ALTER TABLE "ADMIN"."Reload"
    ADD CONSTRAINT "RELOAD_AK" UNIQUE ( "srcid","fainst" )
go

CREATE TABLE "ADMIN"."Report" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"name"                           char(32) NOT NULL
   ,"type"                           integer NOT NULL
   ,"note"                           char(255) NULL
   ,"creator"                        char(128) NOT NULL DEFAULT current user
   ,"created"                        timestamp NOT NULL DEFAULT current timestamp
   ,"rep"                            long binary NOT NULL
   ,CONSTRAINT "REPORT_PK" PRIMARY KEY ("id" ASC) 
) IN "REPORTS"
go

ALTER TABLE "ADMIN"."Report"
    ADD CONSTRAINT "REPORTID_AK" UNIQUE ( "id" )
go

ALTER TABLE "ADMIN"."Report"
    ADD CONSTRAINT "REPORTNAME_AK" UNIQUE ( "name" )
go

GRANT INSERT,DELETE ON "ADMIN"."Report" TO "DESIGNER" 
go

GRANT SELECT ON "ADMIN"."Report" TO "PUBLIC" 
go

GRANT INSERT,DELETE ON "ADMIN"."Report" TO "SCHEDULER" 
go

CREATE TABLE "ADMIN"."Results" (
    "obid"                           integer NOT NULL
   ,"res"                            long binary NOT NULL
   ,"resxml"                         long varchar NULL
   ,CONSTRAINT "RESULTS_PK" PRIMARY KEY ("obid" ASC) 
) IN "RESULTS"
go

GRANT INSERT,DELETE ON "ADMIN"."Results" TO "AUTHOR" 
go

GRANT SELECT ON "ADMIN"."Results" TO "PUBLIC" 
go

GRANT INSERT,DELETE ON "ADMIN"."Results" TO "VERPERM" 
go

CREATE TABLE "ADMIN"."VerError" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"vlstid"                         integer NOT NULL
   ,"code"                           integer NOT NULL
   ,"note"                           char(255) NOT NULL
   ,CONSTRAINT "VERERROR_PK" PRIMARY KEY ("id" ASC) 
)
go

ALTER TABLE "ADMIN"."VerError"
    ADD CONSTRAINT "VERERROR_AK" UNIQUE ( "vlstid","code" )
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."VerError" TO "DESIGNER" 
go

GRANT SELECT ON "ADMIN"."VerError" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."VerList" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"name"                           char(64) NOT NULL
   ,CONSTRAINT "VERLIST_PK" PRIMARY KEY ("id" ASC) 
)
go

ALTER TABLE "ADMIN"."VerList"
    ADD CONSTRAINT "VERLIST_AK" UNIQUE ( "name" )
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."VerList" TO "DESIGNER" 
go

GRANT SELECT ON "ADMIN"."VerList" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."Volume" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"name"                           char(64) NOT NULL
   ,"path"                           char(255) NOT NULL
   ,"creator"                        char(128) NOT NULL DEFAULT current user
   ,"created"                        timestamp NOT NULL DEFAULT current timestamp
   ,CONSTRAINT "VOLUME_PK" PRIMARY KEY ("id" ASC) 
)
go

ALTER TABLE "ADMIN"."Volume"
    ADD CONSTRAINT "VOLUME_AK" UNIQUE ( "name" )
go

GRANT SELECT ON "ADMIN"."Volume" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."Search" (
    "name"                           char(64) NOT NULL
   ,"ver"                            integer NOT NULL
   ,"data"                           long varchar NOT NULL
   ,CONSTRAINT "SEARCH_PK" PRIMARY KEY ("name" ASC) 
)
go

GRANT INSERT,DELETE,UPDATE ON "ADMIN"."Search" TO "AUTHOR" 
go

GRANT SELECT ON "ADMIN"."Search" TO "PUBLIC" 
go

CREATE TABLE "ADMIN"."ZoneStatistic" (
    "id"                             integer NOT NULL DEFAULT autoincrement
   ,"obid"                           integer NOT NULL
   ,"cfgid"                          integer NOT NULL
   ,"created"                        timestamp NOT NULL DEFAULT current timestamp
   ,"doctempl"                       char(64) NOT NULL
   ,"pgnumber"                       integer NOT NULL
   ,"zone"                           char(128) NOT NULL
   ,"quality"                        integer NOT NULL
   ,CONSTRAINT "ZONESTATISTIC_PK" PRIMARY KEY ("id" ASC) 
) IN "STATISTIC"
go

GRANT DELETE ON "ADMIN"."ZoneStatistic" TO "AUTHOR" 
go

GRANT SELECT ON "ADMIN"."ZoneStatistic" TO "PUBLIC" 
go

GRANT INSERT ON "ADMIN"."ZoneStatistic" TO "VERPERM" 
go

commit work
go


-------------------------------------------------
--   Reload data
-------------------------------------------------

INSERT INTO "ADMIN".Folder("id","parent","name") VALUES(1, 1, '$');
go

INSERT INTO "ADMIN".Action("id","name") VALUES(-1,'creation');
INSERT INTO "ADMIN".Action("id","name") VALUES(0,'image control');
INSERT INTO "ADMIN".Action("id","name") VALUES(1,'OCR recognition');
INSERT INTO "ADMIN".Action("id","name") VALUES(2,'classification');
INSERT INTO "ADMIN".Action("id","name") VALUES(3,'1''st verification');
INSERT INTO "ADMIN".Action("id","name") VALUES(4,'2''nd verification');
INSERT INTO "ADMIN".Action("id","name") VALUES(5,'arbitration');
INSERT INTO "ADMIN".Action("id","name") VALUES(6,'certification');
INSERT INTO "ADMIN".Action("id","name") VALUES(7,'control');
INSERT INTO "ADMIN".Action("id","name") VALUES(8,'change of status');
INSERT INTO "ADMIN".Action("id","name") VALUES(9,'export');
INSERT INTO "ADMIN".Action("id","name") VALUES(10,'archive');
INSERT INTO "ADMIN".Action("id","name") VALUES(11,'rescan page');
go

INSERT INTO "ADMIN"."FAOption" VALUES('OCR Statistic', 'NO');
INSERT INTO "ADMIN"."FAOption" VALUES('Compression_bilevel', 'G4');
INSERT INTO "ADMIN"."FAOption" VALUES('Compression_color', 'JpegInTiff');
INSERT INTO "ADMIN"."FAOption" VALUES('Compression_grayscale', 'JpegInTiff');
INSERT INTO "ADMIN"."FAOption" VALUES('Disable BLOB', 'NO');
INSERT INTO "ADMIN"."FAOption" VALUES('Enable log information', 'NO');
INSERT INTO "ADMIN"."FAOption" VALUES('Disable split box', 'YES');
go

LOAD TABLE "ADMIN"."ImageExtension" ("id","ext","name","note")
    FROM 'ImageExtension.dat'
    FORMAT 'TEXT' QUOTES ON
    ORDER OFF ESCAPES ON
    CHECK CONSTRAINTS OFF COMPUTES OFF
    STRIP OFF DELIMITED BY ','
    ENCODING 'windows-1250'
go

LOAD TABLE "ADMIN"."Report" ("id","name","type","note","creator","created","rep")
    FROM 'Report.dat'
    FORMAT 'TEXT' QUOTES ON
    ORDER OFF ESCAPES ON
    CHECK CONSTRAINTS OFF COMPUTES OFF
    STRIP OFF DELIMITED BY ','
    ENCODING 'windows-1250'
go

commit work
go


-------------------------------------------------
--   Create foreign keys
-------------------------------------------------

ALTER TABLE "ADMIN"."AcqBarcode"
    ADD NOT NULL FOREIGN KEY "ACQBARCODE_ACQPROFILE_FK" ("acqid" ASC)
    REFERENCES "ADMIN"."AcqProfile" ("id")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."AcqProfile"
    ADD FOREIGN KEY "ACQPROFILE_CONFIGFILE_FK" ("cfgid" ASC)
    REFERENCES "ADMIN"."ConfigFile" ("id")
    
go

ALTER TABLE "ADMIN"."AcqProfile"
    ADD FOREIGN KEY "ACQPROFILE_DOCTEMPLATE_FK" ("cfgid" ASC,"doctempl" ASC)
    REFERENCES "ADMIN"."DocTemplate" ("cfgid","name")
    
go

ALTER TABLE "ADMIN"."AcqProfile"
    ADD NOT NULL FOREIGN KEY "ACQPROFILE_VOLUME_FK" ("volid" ASC)
    REFERENCES "ADMIN"."Volume" ("id")
    
go

ALTER TABLE "ADMIN"."Box"
    ADD FOREIGN KEY "BOX_ARCHIVE_FK" ("archid" ASC)
    REFERENCES "ADMIN"."Archive" ("id")
    ON DELETE SET NULL 
go

ALTER TABLE "ADMIN"."Box"
    ADD FOREIGN KEY "BOX_IMAGECONTROL_FK" ("imgctrlid" ASC)
    REFERENCES "ADMIN"."History" ("id")
    
go

ALTER TABLE "ADMIN"."Box"
    ADD FOREIGN KEY "BOX_CLASSIFIER_FK" ("classifierid" ASC)
    REFERENCES "ADMIN"."History" ("id")
    
go

ALTER TABLE "ADMIN"."Box"
    ADD FOREIGN KEY "BOX_EXPORT_FK" ("expid" ASC)
    REFERENCES "ADMIN"."Export" ("id")
    ON DELETE SET NULL 
go

ALTER TABLE "ADMIN"."Box"
    ADD NOT NULL FOREIGN KEY "BOX_FOLDER_FK" ("parent" ASC)
    REFERENCES "ADMIN"."Folder" ("id")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."Box"
    ADD NOT NULL FOREIGN KEY "BOX_OBJECT_FK" ("obid" ASC)
    REFERENCES "ADMIN"."Object" ("id")
    
go

ALTER TABLE "ADMIN"."Box"
    ADD NOT NULL FOREIGN KEY "BOX_VOLUME_FK" ("volid" ASC)
    REFERENCES "ADMIN"."Volume" ("id")
    
go

ALTER TABLE "ADMIN"."BoxState"
    ADD NOT NULL FOREIGN KEY "BOXSTATE_BOX_FK" ("id" ASC)
    REFERENCES "ADMIN"."Box" ("obid")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."ClpFolder"
    ADD NOT NULL FOREIGN KEY "CLP_FOLDER_FK" ("id" ASC)
    REFERENCES "ADMIN"."Folder" ("id")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."DocTemplate"
    ADD NOT NULL FOREIGN KEY "DOCTEMPLATE_CONFIGFILE_FK" ("cfgid" ASC)
    REFERENCES "ADMIN"."ConfigFile" ("id")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."DocTemplate"
    ADD FOREIGN KEY "DOCTEMPLATE_VERLIST_FK" ("vlstid" ASC)
    REFERENCES "ADMIN"."VerList" ("id")
    ON DELETE SET NULL 
go

ALTER TABLE "ADMIN"."Document"
    ADD NOT NULL FOREIGN KEY "DOCUMENT_BOX_FK" ("boxid" ASC)
    REFERENCES "ADMIN"."Box" ("obid")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."Document"
    ADD NOT NULL FOREIGN KEY "DOCUMENT_OBJECT_FK" ("obid" ASC)
    REFERENCES "ADMIN"."Object" ("id")
    
go

ALTER TABLE "ADMIN"."ExpError"
    ADD NOT NULL FOREIGN KEY "EXPERROR_DOCUMENT_FK" ("docid" ASC)
    REFERENCES "ADMIN"."Document" ("docid")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."ExportImage"
    ADD NOT NULL FOREIGN KEY "EXPORTIMAGE_VOLUME_FK" ("volid" ASC)
    REFERENCES "ADMIN"."Volume" ("id")
    
go

ALTER TABLE "ADMIN"."ExportImage"
    ADD NOT NULL FOREIGN KEY "EXPORTIMAGE_OBJECT_FK" ("obid" ASC)
    REFERENCES "ADMIN"."Object" ("id")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."ExportImage"
    ADD FOREIGN KEY "EXPORTIMAGE_EXPORT_FK" ("expid" ASC)
    REFERENCES "ADMIN"."Export" ("id")
    ON DELETE SET NULL 
go

ALTER TABLE "ADMIN"."Folder"
    ADD NOT NULL FOREIGN KEY "FOLDER_PARENT_FK" ("parent" ASC)
    REFERENCES "ADMIN"."Folder" ("id")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."History"
    ADD NOT NULL FOREIGN KEY "HISTORY_ACTION_FK" ("action" ASC)
    REFERENCES "ADMIN"."Action" ("id")
    
go

ALTER TABLE "ADMIN"."History"
    ADD NOT NULL FOREIGN KEY "HISTORY_OBJECT_FK" ("obid" ASC)
    REFERENCES "ADMIN"."Object" ("id")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."ICCfgModes"
    ADD NOT NULL FOREIGN KEY "CONFIGFILE_FK" ("idconfig" ASC)
    REFERENCES "ADMIN"."ConfigFile" ("id")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."ICCfgModes"
    ADD NOT NULL FOREIGN KEY "ICMODES_FK" ("idmode" ASC)
    REFERENCES "ADMIN"."ICMode" ("id")
    
go

ALTER TABLE "ADMIN"."ICConfig"
    ADD NOT NULL FOREIGN KEY "CONFIGFILE_FK" ("idconfig" ASC)
    REFERENCES "ADMIN"."ConfigFile" ("id")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."ICConfig"
    ADD FOREIGN KEY "LOADSCRIPT_FK" ("idloadscript" ASC)
    REFERENCES "ADMIN"."ICScript" ("id")
    
go

ALTER TABLE "ADMIN"."ICConfig"
    ADD FOREIGN KEY "SCREENSCRIPT_FK" ("idscreenscript" ASC)
    REFERENCES "ADMIN"."ICScript" ("id")
    
go

ALTER TABLE "ADMIN"."ICConfig"
    ADD FOREIGN KEY "ACCEPTSCRIPT_FK" ("idacceptscript" ASC)
    REFERENCES "ADMIN"."ICScript" ("id")
    
go

ALTER TABLE "ADMIN"."Job"
    ADD NOT NULL FOREIGN KEY "JOB_CONFIGFILE_FK" ("cfgid" ASC)
    REFERENCES "ADMIN"."ConfigFile" ("id")
    
go

ALTER TABLE "ADMIN"."JobTempate"
    ADD NOT NULL FOREIGN KEY "JOBTEMPLATE_JOB_FK" ("jobid" ASC,"cfgid" ASC)
    REFERENCES "ADMIN"."Job" ("id","cfgid")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."JobTempate"
    ADD NOT NULL FOREIGN KEY "JOBTEMPATE_DOCTEMPLATE_FK" ("cfgid" ASC,"doctempl" ASC)
    REFERENCES "ADMIN"."DocTemplate" ("cfgid","name")
    
go

ALTER TABLE "ADMIN"."JobUsers"
    ADD NOT NULL FOREIGN KEY "JOBUSERS_JOB_FK" ("jobid" ASC)
    REFERENCES "ADMIN"."Job" ("id")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."LkpUpdates"
    ADD FOREIGN KEY "LKPUPDATES_DOCUMENT_FK" ("obid" ASC)
    REFERENCES "ADMIN"."Document" ("obid")
    ON DELETE SET NULL 
go

ALTER TABLE "ADMIN"."LkpUpdates"
    ADD NOT NULL FOREIGN KEY "LKPUPDATES_LOOKUP_FK" ("tblowner" ASC,"tblname" ASC)
    REFERENCES "ADMIN"."Lookup" ("tblowner","tblname")
    
go

ALTER TABLE "ADMIN"."LkpUpdates"
    ADD FOREIGN KEY "LKPUPDATES_PARENT_FK" ("parent" ASC)
    REFERENCES "ADMIN"."LkpUpdates" ("id")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."Object"
    ADD FOREIGN KEY "OBJECT_ARBITER_FK" ("arbiterid" ASC)
    REFERENCES "ADMIN"."History" ("id")
    
go

ALTER TABLE "ADMIN"."Object"
    ADD FOREIGN KEY "OBJECT_CERTIFIER_FK" ("certifierid" ASC)
    REFERENCES "ADMIN"."History" ("id")
    
go

ALTER TABLE "ADMIN"."Object"
    ADD FOREIGN KEY "OBJECT_CONFIGFILE_FK" ("cfgid" ASC)
    REFERENCES "ADMIN"."ConfigFile" ("id")
    
go

ALTER TABLE "ADMIN"."Object"
    ADD FOREIGN KEY "OBJECT_CONTROLLER_FK" ("controllerid" ASC)
    REFERENCES "ADMIN"."History" ("id")
    
go

ALTER TABLE "ADMIN"."Object"
    ADD FOREIGN KEY "OBJECT_DOCTEMPLATE_FK" ("cfgid" ASC,"doctempl" ASC)
    REFERENCES "ADMIN"."DocTemplate" ("cfgid","name")
    
go

ALTER TABLE "ADMIN"."Object"
    ADD FOREIGN KEY "OBJECT_VERIFIER1_FK" ("verifier1id" ASC)
    REFERENCES "ADMIN"."History" ("id")
    
go

ALTER TABLE "ADMIN"."Object"
    ADD FOREIGN KEY "OBJECT_VERIFIER2_FK" ("verifier2id" ASC)
    REFERENCES "ADMIN"."History" ("id")
    
go

ALTER TABLE "ADMIN"."Page"
    ADD NOT NULL FOREIGN KEY "PAGE_DOCUMENT_FK" ("obid" ASC)
    REFERENCES "ADMIN"."Document" ("obid")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."PageResults"
    ADD NOT NULL FOREIGN KEY "PAGERESULTS_PAGE_FK" ("id" ASC)
    REFERENCES "ADMIN"."Page" ("id")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."PageTemp"
    ADD NOT NULL FOREIGN KEY "PAGETEMP_OBJECT_FK" ("obid" ASC)
    REFERENCES "ADMIN"."Object" ("id")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."Reload"
    ADD NOT NULL FOREIGN KEY "RELOAD_OBJECT_FK" ("obid" ASC)
    REFERENCES "ADMIN"."Object" ("id")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."Results"
    ADD NOT NULL FOREIGN KEY "RESULTS_DOCUMENT_FK" ("obid" ASC)
    REFERENCES "ADMIN"."Document" ("obid")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."VerError"
    ADD NOT NULL FOREIGN KEY "VERERROR_VERLIST_FK" ("vlstid" ASC)
    REFERENCES "ADMIN"."VerList" ("id")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."ZoneStatistic"
    ADD NOT NULL FOREIGN KEY "ZONESTATISTIC_OBJECT_FK" ("obid" ASC)
    REFERENCES "ADMIN"."Object" ("id")
    ON DELETE CASCADE 
go

ALTER TABLE "ADMIN"."ZoneStatistic"
    ADD NOT NULL FOREIGN KEY "ZONESTATISTIC_CONFIGFILE_FK" ("cfgid" ASC)
    REFERENCES "ADMIN"."ConfigFile" ("id")
    
go

ALTER TABLE "ADMIN"."ZoneStatistic"
    ADD NOT NULL FOREIGN KEY "ZONESTATISTIC_DOCTEMPLATE_FK" ("cfgid" ASC,"doctempl" ASC)
    REFERENCES "ADMIN"."DocTemplate" ("cfgid","name")
    
go

commit work
go


-------------------------------------------------
--   Create indexes
-------------------------------------------------

CREATE INDEX "CLP_STATUS_IDX" ON "ADMIN"."Cleanup"
    ( "status" )
go

commit
go


-------------------------------------------------
--   Create functions
-------------------------------------------------

create function "dbo"."FolderPath"( in @id integer ) 
returns long varchar
begin
  declare @path long varchar;
  declare @name long varchar;
  set @path = '';
  if exists(select "id" from "ADMIN"."Folder" where "id" = @id) then
    while(@id > 1) loop
      select "parent","name" into @id,@name from "ADMIN"."Folder" where "id" = @id;
      set @path = @name || '\\' || @path
    end loop;
    set @path = '$\\' || @path
  end if;
  return @path
end
go

GRANT EXECUTE ON "dbo"."FolderPath" TO "PUBLIC"
go

create function "dbo"."GenFolder"( in @parent integer,in @name char(64) ) 
returns integer
begin
  declare @id integer;
  select "id" into @id from "Admin"."Folder"
    where "parent" = @parent and "name" = @name;
  if sqlcode = 0 then
    return @id
  end if;
  insert into "Admin"."Folder"( "parent","name" ) values( @parent,@name ) ;
  return @@identity
end
go

GRANT EXECUTE ON "dbo"."GenFolder" TO "AUTHOR"
go

create function "dbo"."GenPath"( in "f1" char(64),in "f2" char(64),in "f3" char(64),in "root" integer default 1 ) 
returns integer
begin atomic
  declare @id integer;
  set @id = "GenFolder"("root","f1");
  set @id = "GenFolder"(@id,"f2");
  set @id = "GenFolder"(@id,"f3");
  return(@id)
end
go

GRANT EXECUTE ON "dbo"."GenPath" TO "AUTHOR"
go

create function "ADMIN"."RenumberBox"( in @boxid integer,in @level integer ) 
returns integer
begin
  declare @sum integer;
  /* renumber all document pages, remove empty documents */
  if @level <> 0 then
    select "SUM"("Admin"."RenumberDoc"("obid"))
      into @sum
      from "Admin"."Document" where "boxid" = @boxid
  end if;
  /* renumber all documents in the box */
  update "Admin"."Document" set "number" = "number"()
    where "boxid" = @boxid order by "number" asc;
  /* return document count */
  return @@rowcount
end
go

GRANT EXECUTE ON "ADMIN"."RenumberBox" TO "AUTHOR"
go

create function "ADMIN"."RenumberDoc"( in @obid integer ) 
returns integer
begin
  declare @result integer;
  /* renumber all document pages */
  update "Admin"."Page" set "number" = "number"()
    where "obid" = @obid order by "number" asc;
  /* remove empty document */
  set @result = @@rowcount;
  if @result = 0 then
    delete from "Admin"."Document" where "obid" = @obid
  end if;
  /* return page count */
  return @result
end
go

GRANT EXECUTE ON "ADMIN"."RenumberDoc" TO "AUTHOR"
go

create function "ADMIN"."SplitDoc"( in @obid integer,in @num integer ) 
returns integer
begin
  declare "err_notfound" exception for sqlstate value '02000';
  declare @boxid integer;
  declare @number integer;
  declare @result integer;
  /* check the page number argument value */
  if @num < 2 then
    raiserror 28000 'Page number = %1! is invalid',@num;
    return-1
  end if;
  /* check whether the document is a box */
  select "boxid","number" into @boxid,@number from "ADMIN"."Document" where "obid" = @obid;
  if sqlstate = "err_notfound" then
    raiserror 28000 'Document obid = %1! not found',@obid;
    return-1
  end if;
  /* create object for a new document */
  insert into "ADMIN"."Object"( "status","cfgid","doctempl" ) 
    select-1,"cfgid","doctempl" from "ADMIN"."Object" where "id" = @obid;
  set @result = @@identity;
  /* create document/box for a new object */
  if @boxid = @obid then
    insert into "ADMIN"."Box"( "obid","volid","parent" ) 
      select @result,"volid","parent" from "ADMIN"."Box" where "obid" = @obid;
    insert into "ADMIN"."Document"( "obid","boxid","number" ) values
      ( @result,@result,1 ) 
  else
    update "Admin"."Document" set "number" = -("number"+1)
      where "boxid" = @boxid and "number" > @number;
    update "Admin"."Document" set "number" = -"number"
      where "boxid" = @boxid and "number" < 0;
    /* renumber documents in a box */
    insert into "ADMIN"."Document"( "obid","boxid","number" ) values
      ( @result,@boxid,@number+1 ) 
  end if;
  /* move pages to a new document */
  update "ADMIN"."Page" set "obid" = @result where "obid" = @obid and "number" >= @num;
  if @@rowcount = 0 then
    raiserror 28000 'Page number = %1! not found',@num;
    return-1
  end if;
  /* renumber pages of a new document */
  call "Admin"."RenumberDoc"(@result);
  /* return new document obid */
  return @result
end
go

GRANT EXECUTE ON "ADMIN"."SplitDoc" TO "AUTHOR"
go

commit
go


-------------------------------------------------
--   Create views
-------------------------------------------------

SET TEMPORARY OPTION force_view_creation='ON'
go

create view "ADMIN"."Boxes"
  as select "ADMIN"."Box"."obid",
    "ADMIN"."Box"."volid",
    "ADMIN"."Box"."parent",
    "ADMIN"."Box"."name",
    "ADMIN"."Box"."hold",
    "ADMIN"."Box"."expid",
    "ADMIN"."Box"."archid",
    "ADMIN"."Object"."status",
    "ADMIN"."Object"."error",
    "ADMIN"."Object"."creator",
    "ADMIN"."Object"."created",
    "ADMIN"."Object"."cfgid",
    "ADMIN"."Object"."doctempl",
    "H1"."creator" as "imgctrl",
    "H1"."created" as "imgctrled",
    "H1"."span" as "imgctrlspan",
    "H2"."creator" as "classifier",
    "H2"."created" as "classified",
    "H2"."span" as "clsspan",
    "H3"."creator" as "verifier1",
    "H3"."created" as "verified1",
    "H3"."span" as "ver1span",
    "H3"."quality" as "ver1quality",
    "H4"."creator" as "verifier2",
    "H4"."created" as "verified2",
    "H4"."span" as "ver2span",
    "H4"."quality" as "ver2quality",
    "H5"."creator" as "arbiter",
    "H5"."created" as "arbited",
    "H5"."span" as "arbspan",
    "H5"."quality" as "arbquality",
    "H6"."creator" as "certifier",
    "H6"."created" as "certified",
    "H6"."span" as "cerspan",
    "H6"."quality" as "cerquality",
    "H7"."creator" as "controller",
    "H7"."created" as "controlled",
    "H7"."span" as "conspan"
    from((((((("ADMIN"."Box" key join "ADMIN"."Object")
      left outer join "ADMIN"."History" as "H1" on "ADMIN"."Box"."imgctrlid" = "H1"."id")
      left outer join "ADMIN"."History" as "H2" on "ADMIN"."Box"."classifierid" = "H2"."id")
      left outer join "ADMIN"."History" as "H3" on "ADMIN"."Object"."verifier1id" = "H3"."id")
      left outer join "ADMIN"."History" as "H4" on "ADMIN"."Object"."verifier2id" = "H4"."id")
      left outer join "ADMIN"."History" as "H5" on "ADMIN"."Object"."arbiterid" = "H5"."id")
      left outer join "ADMIN"."History" as "H6" on "ADMIN"."Object"."certifierid" = "H6"."id")
      left outer join "ADMIN"."History" as "H7" on "ADMIN"."Object"."controllerid" = "H7"."id"
go

GRANT SELECT ON "ADMIN"."Boxes" TO "PUBLIC" 
go

create view "ADMIN"."BoxWork"
  as select "ADMIN"."Box"."obid" as "id",
    "ADMIN"."Box"."volid",
    "ADMIN"."Box"."parent",
    "ADMIN"."Box"."name",
    "ADMIN"."Box"."hold",
    "ADMIN"."Box"."expid",
    "ADMIN"."Box"."archid",
    "ADMIN"."Object"."status",
    "ADMIN"."Object"."error",
    "ADMIN"."Object"."creator",
    "ADMIN"."Object"."created",
    "ADMIN"."Object"."cfgid",
    "ADMIN"."Object"."doctempl",
    "ADMIN"."Object"."verifier1",
    "ADMIN"."Object"."verifier2",
    "ADMIN"."Object"."arbiter",
    "ADMIN"."Object"."certifier",
    "ADMIN"."Object"."controller"
    from "ADMIN"."Object" with(index( "OBJECT_PK" ) ) key join "ADMIN"."Box" with(index( "BOX_PK" ) )
    where "ADMIN"."Box"."Hold" = 0
go

GRANT SELECT ON "ADMIN"."BoxWork" TO "PUBLIC" 
go

create view "ADMIN"."ClpFolders"
  as with recursive "Child"( "id","parent","name","level","path" ) as(select "F"."id","F"."parent","F"."name",0 as "level","dbo"."FolderPath"("F"."id")
    from "ADMIN"."Folder" as "F" key join "ADMIN"."ClpFolder" union all
  select "F"."id","F"."parent","F"."name","C"."level"+1,"dbo"."FolderPath"("F"."id")
    from "ADMIN"."Folder" as "F" join "Child" as "C" on "F"."parent" = "C"."id" where "F"."id" <> "F"."parent")
  select * from "Child"
go

GRANT SELECT ON "ADMIN"."ClpFolders" TO "PUBLIC" 
go

create view "ADMIN"."DocTemplates"( "cfgid","name","verlst" ) 
  as select "D"."cfgid","D"."name","V"."name"
    from "ADMIN"."DocTemplate" as "D" left outer join "ADMIN"."VerList" as "V"
go

GRANT SELECT ON "ADMIN"."DocTemplates" TO "PUBLIC" 
go

create view "ADMIN"."DocumentBox"
  as select "ADMIN"."Documents".*,
    "ADMIN"."Boxes"."name",
    "ADMIN"."Boxes"."status" as "boxstatus",
    "ADMIN"."Boxes"."hold",
    "ADMIN"."Boxes"."expid",
    "ADMIN"."Boxes"."archid",
    "ADMIN"."Boxes"."imgctrl",
    "ADMIN"."Boxes"."imgctrled",
    "ADMIN"."Boxes"."classifier",
    "ADMIN"."Boxes"."classified"
    from("ADMIN"."Documents" left outer join "ADMIN"."Boxes" on "ADMIN"."Documents"."boxid" = "ADMIN"."Boxes"."obid")
go

GRANT SELECT ON "ADMIN"."DocumentBox" TO "PUBLIC" 
go

create view "ADMIN"."JobUserConfig" /* view_column_name, ... */
  as select "ADMIN"."Job"."id",
    "ADMIN"."JobUsers"."userid",
    "ADMIN"."Job"."cfgid"
    from "ADMIN"."Job" join "ADMIN"."JobUsers" on "ADMIN"."Job"."id" = "ADMIN"."JobUsers"."jobid"
go

GRANT SELECT ON "ADMIN"."JobUserConfig" TO "PUBLIC" 
go

create view "ADMIN"."DocStat"
  as select "ADMIN"."Object"."status",
    "ADMIN"."Object"."doctempl",
    "ADMIN"."Object"."cfgid",
    "ADMIN"."Object"."error",
    "ADMIN"."Object"."creator",
    "ADMIN"."Object"."created",
    "ADMIN"."Object"."verifier1",
    "ADMIN"."Object"."verifier2",
    "ADMIN"."Object"."arbiter",
    "ADMIN"."Object"."certifier",
    "ADMIN"."Object"."controller",
    "ADMIN"."Box"."hold",
    "ADMIN"."Box"."expid",
    "ADMIN"."Box"."archid"
    from(("ADMIN"."Document" key join "ADMIN"."Object") left outer join "ADMIN"."Box" on "ADMIN"."Document"."boxid" = "ADMIN"."Box"."obid")
go

GRANT SELECT ON "ADMIN"."DocStat" TO "PUBLIC" 
go

create view "ADMIN"."JobUserPerm"
  as select "U"."user_name" as "userid",
    "G"."group_name" as "perm",
    "J"."jobid"
    from(("SYS"."SYSGROUPS" as "G" left outer join "SYS"."SYSUSERPERM" as "U" on "G"."member_name" = "U"."user_name")
      left outer join "ADMIN"."JobUsers" as "J" on "J"."userid" = "U"."user_name")
    where "U"."user_group" <> 'Y'
go

GRANT SELECT ON "ADMIN"."JobUserPerm" TO "PUBLIC" 
go

create view "ADMIN"."Content"
  as select 'type'="ifnull"("D"."docid",1,2),
    'id'="B"."obid",
    "B"."parent",
    'name'="ifnull"("D"."docid","B"."name",'ID: ' || "D"."docid"),
    "D"."fext",
    "B"."creator",
    "B"."created",
    "B"."volid",
    "B"."hold",
    "B"."expid",
    "B"."archid",
    "B"."status",
    "B"."error",
    "B"."cfgid",
    "B"."doctempl",
    "B"."imgctrl",
    "B"."imgctrled",
    "B"."imgctrlspan",
    "B"."classifier",
    "B"."classified",
    "B"."clsspan",
    "B"."verifier1",
    "B"."verified1",
    "B"."ver1span",
    "B"."ver1quality",
    "B"."verifier2",
    "B"."verified2",
    "B"."ver2span",
    "B"."ver2quality",
    "B"."arbiter",
    "B"."arbited",
    "B"."arbspan",
    "B"."arbquality",
    "B"."certifier",
    "B"."certified",
    "B"."cerspan",
    "B"."cerquality",
    "B"."controller",
    "B"."controlled",
    "B"."conspan",
    "P"."endorser"
    from("ADMIN"."Boxes" as "B" left outer join "ADMIN"."Document" as "D" on "B"."obid" = "D"."obid")
      left outer join "ADMIN"."Page" as "P" on "D"."obid" = "P"."obid" and "P"."number" = 1
go

GRANT SELECT ON "ADMIN"."Content" TO "PUBLIC" 
go

create view "ADMIN"."Documents"
  as select "ADMIN"."Document"."obid",
    "ADMIN"."Document"."docid",
    "ADMIN"."Document"."boxid",
    "ADMIN"."Document"."number",
    "ADMIN"."Document"."errauto",
    "ADMIN"."Document"."fext",
    "ADMIN"."Object"."status",
    "ADMIN"."Object"."error",
    "ADMIN"."Object"."creator",
    "ADMIN"."Object"."created",
    "ADMIN"."Object"."cfgid",
    "ADMIN"."Object"."doctempl",
    'verifier1'="H1"."creator",
    'verified1'="H1"."created",
    'ver1span'="H1"."span",
    'ver1quality'="H1"."quality",
    'verifier2'="H2"."creator",
    'verified2'="H2"."created",
    'ver2span'="H2"."span",
    'ver2quality'="H2"."quality",
    'arbiter'="H3"."creator",
    'arbited'="H3"."created",
    'arbspan'="H3"."span",
    'arbquality'="H3"."quality",
    'certifier'="H4"."creator",
    'certified'="H4"."created",
    'cerspan'="H4"."span",
    'cerquality'="H4"."quality",
    'controller'="H5"."creator",
    'controlled'="H5"."created",
    'conspan'="H5"."span"
    from((((("ADMIN"."Document" key join "ADMIN"."Object")
      left outer join "ADMIN"."History" as "H1" on "ADMIN"."Object"."verifier1id" = "H1"."id")
      left outer join "ADMIN"."History" as "H2" on "ADMIN"."Object"."verifier2id" = "H2"."id")
      left outer join "ADMIN"."History" as "H3" on "ADMIN"."Object"."arbiterid" = "H3"."id")
      left outer join "ADMIN"."History" as "H4" on "ADMIN"."Object"."certifierid" = "H4"."id")
      left outer join "ADMIN"."History" as "H5" on "ADMIN"."Object"."controllerid" = "H5"."id"
go

GRANT SELECT ON "ADMIN"."Documents" TO "PUBLIC" 
go

create view "ADMIN"."RecycleFiles"
  as select "R"."pageid","V"."path","R"."fsource",'extension'="isnull"("R"."fext",'TIF')
    from "ADMIN"."Recycle" as "R" join "ADMIN"."Volume" as "V" on "R"."volid" = "V"."id"
    where("R"."spid" = @@spid)
go

GRANT SELECT ON "ADMIN"."RecycleFiles" TO "PUBLIC" 
go

SET TEMPORARY OPTION force_view_creation='OFF'
go

commit
go


-------------------------------------------------
--   Create procedures
-------------------------------------------------

create procedure "ADMIN"."AddBox"( out @num integer,in @prefix char(8) ) 
begin
  declare "err_notfound" exception for sqlstate value '02000';
  declare "c" dynamic scroll cursor for(select "number" from "ADMIN"."AcqBox" where "prefix" = @prefix) for update;
  set temporary option "blocking" = 'On';
  open "c";
  fetch next "c" into @num for update;
  if(sqlstate = "err_notfound") then
    set @num = 1;
    insert into "ADMIN"."AcqBox" values( @prefix,@num ) 
  else
    set @num = @num+1;
    update "ADMIN"."AcqBox" set "number" = @num where current of "c"
  end if;
  close "c";
  set temporary option "blocking" = 'Off'
exception
  when others then
    begin
      set temporary option "blocking" = 'Off';
      resignal
    end
end
go

GRANT EXECUTE ON "ADMIN"."AddBox" TO "AUTHOR"
go

create procedure "ADMIN"."AddFolder"( out @id integer,in @parent integer,in @name char(64) ) 
begin
  declare "i" integer;
  declare "s" char(64);
  declare "ex" exception for sqlstate value '23505';
  set "i" = 1;
  set "s" = @name;
  "restart": loop
    begin
      while exists(select * from "ADMIN"."Folder" where "parent" = @parent and "name" = @name) loop
        set "i" = "i"+1;
        set @name = "s" || ' (' || "i" || ')'
      end loop;
      insert into "ADMIN"."Folder"( "parent","name" ) values( @parent,@name ) ;
      leave "restart"
    exception
      when "ex" then
        -- restart loop
      when others then
        resignal
    end
  end loop "restart";
  set @id = @@identity
end
go

GRANT EXECUTE ON "ADMIN"."AddFolder" TO "AUTHOR"
go

create procedure "ADMIN"."FASplitBox"( in @srcBoxId integer,in @newBoxName char(64),in @splitPosition integer,out @newBoxId integer ) 
begin
  // REMEMBER -> set option ansi_update_constraints = Off
  declare "err_notfound" exception for sqlstate value '02000';
  declare @boxid integer;
  declare @parent integer;
  declare @cfgid integer;
  declare @doctempl char(64);
  declare @status integer;
  declare @volid integer;
  declare @hold integer;
  declare @creator char(128);
  declare @created timestamp;
  declare @changesIntroduced integer;
  declare @docsCount integer;
  declare @newobid integer;
  select "obid","parent","cfgid","doctempl","status","volid","hold","creator","created"
    into @boxid,@parent,@cfgid,@doctempl,@status,@volid,@hold,@creator,@created
    from "ADMIN"."Box" as "B","ADMIN"."Object" as "O"
    where "B"."obid" = @srcBoxId and "O"."id" = @srcBoxId;
  if @boxid is null then
    raiserror 23000 'ERROR - Given box does not exist!'
  end if;
  // check if there are any documents left for the split box to be created
  select "count"() into @docsCount from "ADMIN"."Document" where "boxid" = @boxid and "number" >= @splitPosition;
  if @docsCount = 0 then
    raiserror 23001 'ERROR - The resulting split box will be empty!'
  end if;
  // create a new box
  insert into "ADMIN"."Object"( "id","cfgid","status","error","doctempl" ) values( default,@cfgid,@status,0,@doctempl ) ;
  set @newobid = @@identity;
  insert into "ADMIN"."Box"( "obid","volid","parent","name","hold" ) values( @newobid,@volid,@parent,@newBoxName,0 ) ;
  // move documents to a new box
  update "ADMIN"."Document" set "boxid" = @newobid,"number" = "number"-@splitPosition+1 where "boxid" = @boxid and "number" >= @splitPosition order by "number" asc;
  // return new box id
  set @newBoxId = @newobid
end
go

GRANT EXECUTE ON "ADMIN"."FASplitBox" TO "ADMIN"
go

create procedure "ADMIN"."MergeBox"( in @destid integer,in @srcid integer ) 
begin
  declare @num integer;
  declare @docid integer;
  select "count"() into @num from "Admin"."Document" where "boxid" = @destid;
  select "docid" into @docid from "Admin"."Document" where "obid" = @srcid;
  /* Transfer documents at the end of the destination box. */
  update "Admin"."Document" set "boxid" = @destid,"number" = "number"()+@num
    where "boxid" = @srcid order by "number" asc;
  /* If the source is a document, does not delete it from Object. */
  if(@docid is not null) then
    update "Admin"."Box" set "hold" = -1 where "obid" = @srcid
  end if;
  delete from "Admin"."Box" where "obid" = @srcid
end
go

GRANT EXECUTE ON "ADMIN"."MergeBox" TO "AUTHOR"
go

commit
go


-------------------------------------------------
--   Create triggers
-------------------------------------------------

create trigger "OnRecycle" before delete order 1 on "ADMIN"."Box"
referencing old as "rold"
for each row begin
  insert into "ADMIN"."Recycle"(
    select @@spid,"rold"."volid","id",0,null from "ADMIN"."Page"
      where "obid" = any(select "obid" from "ADMIN"."Document" where "boxid" = "rold"."obid"));
  insert into "ADMIN"."Recycle"(
    select @@spid,"rold"."volid","docid",1,"fext" from "ADMIN"."Document"
      where "boxid" = "rold"."obid" and "fext" is not null);
  insert into "ADMIN"."Recycle"(
    select @@spid,"rold"."volid","id",0,'INT' from "ADMIN"."PageTemp"
      where "obid" = "rold"."obid")
end
go

create trigger "OnDelete" after delete order 1 on "ADMIN"."Box"
referencing old as "rold"
for each row begin
  /* Special case for merging operation. */
  if("rold"."hold" <> -1) then
    delete from "ADMIN"."Object" where "id" = "rold"."obid"
  end if
end
go

create trigger "OnUpdate" before update order 1 on "ADMIN"."ClpOptions"
referencing new as "rnew"
for each row begin
  set "rnew"."editor" = current user;
  set "rnew"."edited" = current timestamp
end
go

create trigger "OnDelete" before delete order 1 on "ADMIN"."Document"
referencing old as "rold"
for each row begin
  insert into "ADMIN"."Recycle"(
    select @@spid,"B"."volid","P"."id",0,null from "ADMIN"."Page" as "P","ADMIN"."Box" as "B"
      where "P"."obid" = "rold"."obid" and "B"."obid" = "rold"."boxid");
  delete from "ADMIN"."Object" where "id" = "rold"."obid"
end
go

create trigger "OnInsert" before insert order 1 on "ADMIN"."Export"
referencing new as "rnew"
for each row begin
  declare @dnum integer;
  select "max"("dnumber") into @dnum from "ADMIN"."Export"
    where "date"("created") = "date"("rnew"."created");
  set "rnew"."dnumber" = "ifnull"(@dnum,1,@dnum+1)
end
go

create trigger "OnDelete" after delete order 1 on
"ADMIN"."ExportImage"
referencing old as "rold"
for each row begin
  insert into "ADMIN"."Recycle" values( @@spid,"rold"."volid","rold"."id",0,"rold"."fext" ) 
end
go

create trigger "OnInsert" after insert order 1 on "ADMIN"."Object"
referencing new as "rnew"
for each row begin
  insert into "ADMIN"."History"( "action","obid","creator","created" ) values
    ( -1,"rnew"."id","rnew"."creator","rnew"."created" ) 
end
go

create trigger "OnVerifier1" before update of "verifier1id"
order 1 on "ADMIN"."Object"
referencing new as "rnew"
for each row
begin
  set "rnew"."verifier1" = "IFNULL"("rnew"."verifier1id",null,current user)
end
go

create trigger "OnVerifier2" before update of "verifier2id"
order 2 on "ADMIN"."Object"
referencing new as "rnew"
for each row
begin
  set "rnew"."verifier2" = "IFNULL"("rnew"."verifier2id",null,current user)
end
go

create trigger "OnArbiter" before update of "arbiterid"
order 3 on "ADMIN"."Object"
referencing new as "rnew"
for each row
begin
  set "rnew"."arbiter" = "IFNULL"("rnew"."arbiterid",null,current user)
end
go

create trigger "OnCertifier" before update of "certifierid"
order 4 on "ADMIN"."Object"
referencing new as "rnew"
for each row
begin
  set "rnew"."certifier" = "IFNULL"("rnew"."certifierid",null,current user)
end
go

create trigger "OnController" before update of "controllerid"
order 5 on "ADMIN"."Object"
referencing new as "rnew"
for each row
begin
  set "rnew"."controller" = "IFNULL"("rnew"."controllerid",null,current user)
end
go

create trigger "OnUpdate" before update order 1 on "ADMIN"."AcqProfile"
referencing new as "rnew"
for each row when("rnew"."editor" is not null)
begin
  set "rnew"."editor" = current user;
  set "rnew"."edited" = current timestamp
end
go

commit
go


-------------------------------------------------
--   Create events
-------------------------------------------------

CREATE EVENT "ADMIN"."AutoDelete" DISABLE 
HANDLER
begin
  insert into "ADMIN"."Cleanup"( "status" ) values( 0 ) 
end
go


-------------------------------------------------
--   Create options
-------------------------------------------------

SET OPTION date_order =
go

SET OPTION PUBLIC.preserve_source_format =
go

SET OPTION "PUBLIC"."ansi_update_constraints"='OFF'
go

SET OPTION "PUBLIC"."optimization_goal"='First-row'
go

SET OPTION "PUBLIC"."prefetch"='Off'
go
